
; 
; 
; 

	option casemap :none				; case sensitive
	include test.OpenGLx64.inc

.code
	
; 
; 
; 

WinMainCRTStartup proc ;hInst :DWORD, hPrevInst :DWORD, CmdLine :DWORD, CmdShow :DWORD
	sub rsp, sizeof(struct_var6)

	invoke GetModuleHandle, NULL							; get a module handle
	mov hInstance, rax										; and store it
	invoke DialogBoxParam, hInstance, IDD_DIALOG, NULL, offset DlgProc, NULL
	invoke ExitProcess, NULL								; cleanup and kill process

	invoke ExitProcess, rcx
;	sub rsp, sizeof(struct_var6)
WinMainCRTStartup endp

; 
; 
; 

DlgProc proc ;hWin:HWND, uMsg:UINT, wParam:WPARAM, lParam:LPARAM
	push r12
	sub rsp, sizeof(struct_var4) + 8	; +8 because of rsp alignment, would need it without that push r12

	cmp rdx, WM_INITDIALOG									; WM_INITDIALOG
	jne _no_initdialog
		mov r12, rcx
		invoke ShowWindow, r12, SW_MINIMIZE					; pop up effect
		invoke LoadIcon, hInstance, IDI_ICON				; set application icon
		mov hIcon, rax										; and store it's handle
		invoke SendMessage, r12, WM_SETICON, 1, hIcon		; show the icon
		invoke SendMessageA, r12, WM_SETTEXT, 0, offset szAppName ; show application name
		invoke ShowWindow, r12, SW_SHOWNORMAL				; show the final dialog 
		invoke myOGL_InitGL, r12
		invoke SetTimer, r12, 1, 10, NULL					; setup a timer
		jmp _endif

_no_initdialog:
	cmp rdx, WM_TIMER										; WM_TIMER
	jne _no_timer
		invoke myOGL_DrawScene								; redraw openGL scene
		xor rax, rax
		jmp no_rax
		;jmp _endif

_no_timer:
	cmp rdx, WM_CLOSE										; WM_CLOSE
	jne _no_close
		mov r12, rcx
		invoke ShowWindow, r12, SW_MINIMIZE					; minimize the window to taskbar
		invoke KillTimer, r12, 1							; delete timer
		invoke myOGL_KillGL									; delete openGL crap
		invoke ReleaseDC, r12, hDC							; release device context
		invoke EndDialog, r12, 0							; end the dialog
		jmp _endif

_no_close:
	cmp rdx, WM_COMMAND										; WM_COMMAND
	jne _no_command
		nop													; do nothing
		jmp _endif

_no_command:
	xor rax, rax
	jmp no_rax												; and continue
_endif:

	mov eax, TRUE											; message handled with success
no_rax:
	add rsp, sizeof(struct_var4) + 8
	pop r12
	ret
DlgProc endp			

; 
; 
; 

myOGL_InitGL proc ;theWindowHandle:DWORD
	sub rsp, sizeof(struct_var4)

	; rcx = theWindowHandle
	invoke GetDlgItem, rcx, IDI_OPENGL						; the static item which shows openGL
	mov hOGLWindow, rax										; store it's handle
	invoke GetDC, hOGLWindow								; get the device context
	mov hDC, rax											; and store it
	invoke GetClientRect, hOGLWindow, offset staticRect		; we need the dimensions of the static

	mov pfd.nSize, sizeof(PIXELFORMATDESCRIPTOR)			; setup pixelformatdescriptor struct
	mov pfd.nVersion, 1
	mov pfd.dwFlags, PFD_DRAW_TO_WINDOW or PFD_SUPPORT_OPENGL or PFD_DOUBLEBUFFER
	mov pfd.iPixelType, PFD_TYPE_RGBA
	mov pfd.cColorBits, 16
	mov pfd.cDepthBits, 16
	mov pfd.dwLayerMask, PFD_MAIN_PLANE

	lea rdx, pfd
	invoke ChoosePixelFormat, hDC, rdx						; and the correct pixelformat
	mov pixel_format, rax									; thats the correct one
	lea r8, pfd
	invoke SetPixelFormat, hDC, pixel_format, r8			; so set it!
	invoke wglCreateContext, hDC							; create rendering context
	mov hRC, rax											; store the handle
	invoke wglMakeCurrent, hDC, hRC							; it's our OpenGL context
	mov r9d, staticRect.bottom
	mov r8d, staticRect.right
	invoke glViewport, 0, 0, r8, r9 						;reset viewport
	invoke glMatrixMode, GL_PROJECTION						; select projection matrix
	invoke glLoadIdentity									; reset it

	; double precision float
	movsd xmm3, q_n100
	movsd xmm2, q_n0_1
	movss xmm1, staticRect.right
	divss xmm1, staticRect.bottom							; dividing width by height and
	cvtps2pd xmm1, xmm1										; stack as a double
	movsd xmm0, q_n45
	invoke gluPerspective, xmm0, xmm1, xmm2, xmm3

	invoke glMatrixMode, GL_MODELVIEW						; select modelview matrix
	invoke glLoadIdentity									; reset it
	invoke glShadeModel, GL_SMOOTH							; Enable Smooth Shading
	xorps xmm3, xmm3
	xorps xmm2, xmm2
	xorps xmm1, xmm1
	xorps xmm0, xmm0
	invoke glClearColor, xmm0, xmm1, xmm2, xmm3				; Black Background

	; double precision float
	movsd xmm0, q_n1
	invoke glClearDepth, xmm0								; Depth Buffer Setup

	invoke glEnable, GL_DEPTH_TEST							; Enables Depth Testing
	invoke glDepthFunc, GL_LEQUAL							; The Type Of Depth Testing To Do
	invoke glHint, GL_PERSPECTIVE_CORRECTION_HINT, GL_NICEST; Really Nice Perspective Calculations

	add rsp, sizeof(struct_var4)
	xor rax, rax
	ret
myOGL_InitGL endp

; 
; 
; 

myOGL_DrawScene proc
	sub rsp, sizeof(struct_var4)

	invoke glClear, GL_COLOR_BUFFER_BIT or GL_DEPTH_BUFFER_BIT	; Clear Screen And Depth Buffer

	movss xmm2, n1	; 1.0f
	movss xmm1, n1	; 1.0f
	movss xmm0, n1	; 1.0f
	invoke glColor3f, xmm0, xmm1, xmm2							; white color, it looks like you have to set the color in 64bit apps!!
	invoke glLoadIdentity										; Reset The Current Modelview Matrix

	; -- draw the triangle
	movss xmm2, nm6
	movss xmm1, n0
	movss xmm0, nm1_5
	invoke glTranslatef, xmm0, xmm1, xmm2
	invoke glBegin, GL_TRIANGLES								; start
	movss xmm2, n0
	movss xmm1, n1
	movss xmm0, n0
	invoke glVertex3f, xmm0, xmm1, xmm2
	movss xmm2, n0
	movss xmm1, nm1
	movss xmm0, nm1
	invoke glVertex3f, xmm0, xmm1, xmm2
	movss xmm2, n0
	movss xmm1, nm1
	movss xmm0, n1
	invoke glVertex3f, xmm0, xmm1, xmm2
	invoke glEnd 												; end
	
	; -- draw the quad
	movss xmm2, n0
	movss xmm1, n0
	movss xmm0, n3
	invoke glTranslatef, xmm0, xmm1, xmm2
	invoke glBegin, GL_QUADS									; start
	movss xmm2, n0
	movss xmm1, n1
	movss xmm0, nm1
	invoke glVertex3f, xmm0, xmm1, xmm2
	movss xmm2, n0
	movss xmm1, n1
	movss xmm0, n1
	invoke glVertex3f, xmm0, xmm1, xmm2
	movss xmm2, n0
	movss xmm1, nm1
	movss xmm0, n1
	invoke glVertex3f, xmm0, xmm1, xmm2
	movss xmm2, n0
	movss xmm1, nm1
	movss xmm0, nm1
	invoke glVertex3f, xmm0, xmm1, xmm2
	invoke glEnd												; end 

	invoke SwapBuffers, hDC										; show the result

	add rsp, sizeof(struct_var4)
	xor rax, rax
	ret
myOGL_DrawScene endp

; 
; 
; 

myOGL_KillGL proc
	sub rsp, sizeof(struct_var4)

	invoke wglMakeCurrent, NULL, NULL
	invoke wglDeleteContext, hRC

	add rsp, sizeof(struct_var4)
	xor rax, rax
	ret
myOGL_KillGL endp

; 
; 
; 

end

; 
; 
; 
