; #########################################################################

	;include files
	;~~~~~~~~~~~~~
	include \masm64\include\windows64igor.inc
	include \masm64\include\user64igor.inc
	include \masm64\include\user64.inc
	include \masm64\include\gdi64igor.inc
	include \masm64\include\kernel64igor.inc
	include \masm64\include\opengl64igor.inc
	include \masm64\include\glu64igor.inc

	;libraries
	;~~~~~~~~~
	includelib \masm64\lib\gdi32.lib
	includelib \masm64\lib\user32.lib
	includelib \masm64\lib\kernel32.lib
	includelib \masm64\lib\opengl32.lib
	includelib \masm64\lib\glu32.lib

; #########################################################################

	; PIXELFORMATDESCRIPTOR struct - 40 bit
	PIXELFORMATDESCRIPTOR struct
		nSize					word	?
		nVersion				word	?
		dwFlags					dword	?
		iPixelType				byte	?
		cColorBits				byte	?
		cRedBits				byte	?
		cRedShift				byte	?
		cGreenBits				byte	?
		cGreenShift				byte	?
		cBlueBits				byte	?
		cBlueShift				byte	?
		cAlphaBits				byte	?
		cAlphaShift				byte	?
		cAccumBits				byte	?
		cAccumRedBits			byte	?
		cAccumGreenBits			byte	?
		cAccumBlueBits			byte	?
		cAccumAlphaBits			byte	?
		cDepthBits				byte	?
		cStencilBits			byte	?
		cAuxBuffers				byte	?
		iLayerType				byte	?
		bReserved				byte	?
		dwLayerMask				dword	?
		dwVisibleMask			dword	?
		dwDamageMask			dword	?
	PIXELFORMATDESCRIPTOR ends

	; var structures
	struct_var4 struct
		var_rcx		qword ?
		var_rdx		qword ?
		var_r8		qword ?
		var_r9 		qword ?
		var_ret		qword ?
	struct_var4 ends
	
	struct_var6 struct
		var_rcx		qword ?
		var_rdx		qword ?
		var_r8		qword ?
		var_r9 		qword ?
		v05 		qword ?
		v06 		qword ?
		var_ret		qword ?
	struct_var6 ends
	struct_var5 equ <struct_var6>	; because of alignment
	; var structures

	; WARNING: uses RAX!
	invoke macro function:REQ,vr1,vr2,vr3,vr4, vss:VARARG	;vs5,vs6,vs7,vs8,vs9,vs10,vs11,vs12
		local cnt, result
		cnt = 20h							; start from 5th param
		for vs, <vss>
			result = opattr(vs)				; check is it register
			if result eq 48					; register?
				ifidni <vs>, <rax>
					.err <dont use r-a-x!!>
				endif
				mov [rsp+cnt], vs			; just move it from register
			else
				mov rax, vs					; move from memory to register
				mov [rsp+cnt], rax			; move from register
			endif
			cnt = cnt + 8h					; go to next stack location
		endm

		if cnt eq 20h
			;
		else
			for vs, <vr1,vr2,vr3,vr4>
				ifidni <vs>, <rax>
					.err <dont use r-a-x!!>
				endif
			endm
		endif

		ifnb <vr4>							; if not blank
			ifdifi <r9>, <vr4>				; if vr4 != r9
				ifdifi <xmm3>, <vr4>		; if vr4 != xmm3
					ifdifi <vr4>, <0>
						mov r9, vr4			; move to r9
					else
						xor r9, r9			; set r9 to zero
					endif
				endif
			endif
		endif
		ifnb <vr3>
			ifdifi <r8>, <vr3>
				ifdifi <xmm2>, <vr3>
					ifdifi <vr3>, <0>
						mov r8, vr3
					else
						xor r8, r8
					endif
				endif
			endif
		endif
		ifnb <vr2>
			ifdifi <rdx>, <vr2>
				ifdifi <xmm1>, <vr2>
					ifdifi <vr2>, <0>
						mov rdx, vr2
					else
						xor rdx, rdx
					endif
				endif
			endif
		endif
		ifnb <vr1>
			ifdifi <rcx>, <vr1>
				ifdifi <xmm0>, <vr1>
					ifdifi <vr1>, <0>
						mov rcx, vr1
					else
						xor rcx, rcx
					endif
				endif
			endif
		endif
		call function
	endm

.data?
	hInstance			dq ?		; application instance
	hIcon				dq ?		; application icon 
	hDC					dq ?		; device context
	hRC					dq ?		; openGL rendering context
	hOGLWindow			dq ?		; openGL window handle
	staticRect			RECT <?>	; dimensions of static openGL "window"

	pixel_format		dq ?
	pfd					PIXELFORMATDESCRIPTOR <?>

.data
	szAppName			db "OpenGL in a Box (NeHe Lesson02)- by Pegasus", 0 ; dialog caption

.const
	IDI_ICON			equ 100		; application icon
	IDD_DIALOG			equ 1000	; dialog resource
	IDI_OPENGL			equ 1001	; openGL static area

	; floating point values
	q_n100				dq  100.0f
	q_n0_1				dq    0.1f
	q_n1				dq    1.0f
	q_n45				dq   45.0f

	n0					dd    0.0f
	n0_1				dd    0.1f
	n1					dd    1.0f
	n1_5				dd    1.5f
	n45					dd   45.0f
	n100				dd  100.0f
	nm1_5				dd   -1.5f
	nm1					dd   -1.0f
	n3					dd	  3.0f
	nm6					dd   -6.0f
